#include "libscio.hpp"

sc::io::imemfile::imemfile(const std::string& path) : std::istream {&_buf},
                                                      _file {path},
                                                      _buf {_file.mapping(), _file.size()} {}

sc::io::imemfile::imemfile(imemfile&& other) : std::istream {&_buf},
                                               _file {std::move(other._file)},
                                               _buf {std::move(other._buf)} {}

void sc::io::imemfile::open(const std::string& path, std::ios_base::openmode /* mode */) {
    _file.open(path);
    _buf.init(_file.mapping(), _file.size());
}
